CraftList2 = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1")
local L = AceLibrary("AceLocale-2.2"):new("CraftList2")
local G = AceLibrary("Gratuity-2.0")
local BTS= AceLibrary("Babble-Tradeskill-2.2")
local waterfall = AceLibrary("Waterfall-1.0")
local self=CraftList2

local prefix_ench = "!enchant"
local prefix_gem = "!gem"
local prefix_other = "!craft"
local prefix_answers = "cL2>"

local mem_search={}
local mem_next={}
local mem_trigger={}

local enchant_localtest=""
local gem_localtest=""
local craft_localtest=""

local enchant_send=""
local gem_send=""
local craft_send=""

local function Respond(message,sender)
	if not sender then return end
	ChatThrottleLib:SendChatMessage("NORMAL", prefix_answers, prefix_answers.." "..message, "WHISPER", nil, sender)
end


local function GetArgs(text, separator)
	local args = {}
	local i = 0
	for value in string.gmatch(text, "[^"..separator.."]+") do
		i = i + 1
		args[i] = value
	end	
	return args
end


local function RecomposeLink(argument)
	local message=argument
	for k,v in pairs(message) do
		if strfind(v,"|cff") then
				if strfind(v,"|h|r") then return message
				else 
					message[k]=v.." "..message[k+1]
					table.remove(message,k+1)
					return RecomposeLink(message)
				end
		end
	end
	return message
end

local function ScanCraft(craftname)
	if not self.db.realm.data[UnitName("player")] then self.db.realm.data[UnitName("player")] = {} end
	if not self.db.realm.data[UnitName("player")][craftname] then self.db.realm.data[UnitName("player")][craftname] = {} end
	local craftdata = {}
	for i=1,GetNumCrafts() do
		local skillname, craftSubSpellName, skilltype = GetCraftInfo(i)
		if skilltype~="header" and skillname then
			local craftinfo = {}
			local link = GetCraftItemLink(i)
			local desc = GetCraftDescription(i)
			if desc == nil then desc = "" end
			craftinfo["name"]=skillname
			craftinfo["link"] = link
			craftinfo["desc"] = desc
			for k,v in pairs(self.db.realm.data[UnitName("player")][craftname]) do
				if v.name==skillname then 
					if v.ignored then craftinfo.ignored=true else craftinfo.ignored=false end
				end
			end
			table.insert(craftdata,craftinfo)
		end	
	end
	self.db.realm.data[UnitName("player")][craftname] = craftdata
end

local function ScanTS(tsname)
	if not self.db.realm.data[UnitName("player")] then self.db.realm.data[UnitName("player")] = {} end
	if not self.db.realm.data[UnitName("player")][tsname] then self.db.realm.data[UnitName("player")][tsname] = {} end
	local tsdata = {}
	for i=1,GetNumTradeSkills() do
		local skillname, skilltype, numAvailable, isExpanded = GetTradeSkillInfo(i)
		if skilltype ~= "header" then
			local tsinfo = {}
			local itemlink = GetTradeSkillItemLink(i)
			local recipelink = GetTradeSkillRecipeLink(i)
			local reg = {}
			for j=1,GetTradeSkillNumReagents(i) do
				table.insert(reg,GetTradeSkillReagentItemLink(i,j))
			end
			tsinfo["name"]=skillname
			tsinfo["itemlink"] = itemlink
			tsinfo["recipelink"] = recipelink
			tsinfo["reg"] = reg
			for k,v in pairs(self.db.realm.data[UnitName("player")][tsname]) do
				if v.name==skillname then 
					if v.ignored then tsinfo.ignored=true else tsinfo.ignored=false end
				end
			end
			table.insert(tsdata,tsinfo)
		end	
	end
	self.db.realm.data[UnitName("player")][tsname] = tsdata
end

function CraftList2:CRAFT_SHOW()
	local craftname= GetCraftName()
	ScanCraft(craftname)
end

function CraftList2:TRADE_SKILL_SHOW()
	local tsname= GetTradeSkillLine()
	ScanTS(tsname)
end

local function SendResults(searchresult,sender,source)
	if not searchresult then return end
	if #searchresult == 0 then Respond(L["Nothing found."],sender) return end
	
	if source=="guild" and self.db.realm.shortguild then
		local charstrings=0
		for i=1,#searchresult do
			if string.sub(searchresult[i],1,string.len(L["Results for "]))==L["Results for "] then charstrings=charstrings+1 end
		end
		Respond((L["%d result(s)."]):format(charstrings).." "..L["Whisper me the same command to get the actual results."] ,sender)
	
	else
		if mem_next[sender] and mem_next[sender] > 0 then 
			for i=1,mem_next[sender] do
				table.remove(searchresult,1)
			end
		end
		
		local max = self.db.realm.maxresults
		local endstring
		if #searchresult < max  or max == 0 then 
			max = #searchresult 
			local charstrings=0
			for i=1,max do
				if string.sub(searchresult[i],1,string.len(L["Results for "]))==L["Results for "] then charstrings=charstrings+1 end
			end
			endstring=(L["%d result(s)."]):format(#searchresult - charstrings)
		else
			endstring=(L["Maximum results exceeded, be more specific or use '%s next' to get next results (%d result(s) remaining)."]):format(mem_trigger[sender],#searchresult-max)
		end

		for i=1,max do
			Respond(searchresult[i],sender)
		end
		Respond(endstring,sender)
	end
end

local function HandleEnchant(argum,sender)
	if #argum == 0 then 
		Respond(L["Usage: !enchant <any combination of keywords and itemlinks>"],sender) 
		Respond(L["Usage: example: !enchant [Ashbringer] 35 heal"],sender)
		return 
	end

	-- replace an itemlink with the piece of armor 
	for k,v in pairs(argum) do
		if strfind(argum[k],"|cff") and strfind(argum[k],"|h|r") then
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(argum[k])
			if sType == L["Armor"] then 
				local b=0
				if iel=="INVTYPE_CHEST" then b=L["Chest"]
				elseif iel=="INVTYPE_ROBE" then b=L["Chest"]
				elseif iel=="INVTYPE_FEET" then b=L["Boots"]
				elseif iel=="INVTYPE_WRIST" then b=L["Bracer"]
				elseif iel=="INVTYPE_HAND" then b=L["Gloves"]
				elseif iel=="INVTYPE_CLOAK" then b=L["Cloak"]
				elseif iel=="INVTYPE_SHIELD" then b=L["Shield"]
				elseif iel=="INVTYPE_FINGER" then b=L["Ring"]
				else Respond(L["Error! Cannot enchant that."],sender) return end
				argum[k]=b
			elseif sType==L["Weapon"] then 
				local b=0
				if iel=="INVTYPE_2HWEAPON" then b=L["Weapon"]
				elseif iel=="INVTYPE_WEAPONMAINHAND" then b=L["Enchant Weapon"]
				elseif iel=="INVTYPE_WEAPONOFFHAND" then b=L["Enchant Weapon"]
				elseif iel=="INVTYPE_WEAPON" then b=L["Enchant Weapon"]
				else Respond(L["Error! Cannot enchant that."],sender) return end
				argum[k]=b
			end
		end
	end
	-- done replacing
	
	-- building the results
	local searchresult={}
	if self.db.realm.data=={} then Respond(L["Database is currently empty."],sender) return end
	
	for character, tradeskill in pairs(self.db.realm.data) do
		if ( not self.db.realm.currentcharonly ) or ( self.db.realm.currentcharonly and character==UnitName("player")  ) then
			table.insert(searchresult,L["Results for "]..character..":")
			if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
			if tradeskill[BTS["Enchanting"]] and not self.db.realm.ignored_crafts[character][BTS["Enchanting"]] then
				for nb,info in pairs(tradeskill[BTS["Enchanting"]]) do
					local match=0
					local enchantname=string.lower(info["name"])
					local enchantdesc=string.lower(info["desc"])
					for j=1,#argum do
						if strfind(enchantname, string.lower(argum[j])) then match=match+1 
						elseif strfind(enchantdesc, string.lower(argum[j])) then match=match+1
						end
					end 
					if match==#argum and not info["ignored"] then table.insert(searchresult,info["link"]) end	
				end	
			end
			if searchresult[#searchresult]==L["Results for "]..character..":" then table.remove(searchresult,#searchresult) end
		end
	end
	--SendResults(searchresult,sender)
	return searchresult
end

local function HandleGem(argum,sender)
	if #argum == 0 then 
		Respond(L["Usage: !gem <any combination of color/stat/reagent/text>"],sender) 
		Respond(L["Usage: example: !gem red, !gem [Talasite], !gem 5 strength"],sender)
		return 
	end
	
	local searchresult={}
	if self.db.realm.data=={} then Respond(L["Database is currently empty."],sender) return end
	
	
	for k,v in pairs(argum) do
		if strfind(argum[k],"|cff") and strfind(argum[k],"|h|r") then
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(argum[k])
			argum[k] = sName
		elseif argum[k]== L["orange"] then 
			argum[k]=L["red"]
			table.insert(argum,L["yellow"])
		elseif argum[k]== L["purple"] then 
			argum[k]=L["red"]
			table.insert(argum,L["blue"])
		elseif argum[k]== L["green"] then 
			argum[k]=L["yellow"]
			table.insert(argum,L["blue"])
		end
	end


	for character, tradeskill in pairs(self.db.realm.data) do
		if ( not self.db.realm.currentcharonly ) or ( self.db.realm.currentcharonly and character==UnitName("player")  ) then
			table.insert(searchresult,L["Results for "]..character..":")
			if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
			if tradeskill[BTS["Jewelcrafting"]] and not self.db.realm.ignored_crafts[character][BTS["Jewelcrafting"]] then
				for nb,info in pairs(tradeskill[BTS["Jewelcrafting"]]) do
					local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(info["itemlink"])
					if sType== L["Gem"] then
						local match=0
						local gemname=string.lower(info["name"])
						G:SetHyperlink(info["itemlink"])
						local gemdesc=string.lower(G:GetLine(2))
						local gemcolor=string.lower(G:GetLine(G:NumLines()) )
						local gemrarity
						
						if iRarity==0 then gemrarity = string.lower(L["Poor"])
						elseif iRarity==1 then gemrarity=string.lower(L["Common"])
						elseif iRarity==2 then gemrarity=string.lower(L["Uncommon"])
						elseif iRarity==3 then gemrarity=string.lower(L["Rare"])
						elseif iRarity==4 then gemrarity=string.lower(L["Epic"])
						elseif iRarity==5 then gemrarity=string.lower(L["Legendary"])
						end
						
						local reg = info["reg"]
						for j=1,#argum do
							if strfind(gemname, string.lower(argum[j])) then match=match+1 
							elseif strfind(gemdesc, string.lower(argum[j])) then match=match+1
							elseif strfind(gemcolor,string.lower(argum[j])) then match = match+1
							elseif strfind(gemcolor,string.lower(argum[j])) then match = match+1
							elseif gemrarity and strfind(gemrarity,string.lower(argum[j])) then match = match+1
							else 
								for k,v in pairs(reg) do
									if strfind(v,argum[j]) then match = match+1 end
								end
							end
						end 
						if match==#argum and not info["ignored"] then table.insert(searchresult,info["itemlink"]) end	
					end
				end	
			end
			if searchresult[#searchresult]==L["Results for "]..character..":" then table.remove(searchresult,#searchresult) end
		end
	end

	--SendResults(searchresult,sender)
	return searchresult
end

local function HandleCraft(argum,sender)
	if #argum == 0 then 
		Respond(L["Usage: !craft <any combination of reagent/text>"],sender) 
		Respond(L["Usage: example: !craft belt of blasting, !craft belt [Primal Fire]"], sender)
		return 
	end
	
	local searchresult={}
	if self.db.realm.data=={} then Respond(L["Database is currently empty."],sender) return end
	
	
	for k,v in pairs(argum) do
		if strfind(argum[k],"|cff") and strfind(argum[k],"|h|r") then
			local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, iel = GetItemInfo(argum[k])
			argum[k] = sName
		end
	end


	for character, tradeskill in pairs(self.db.realm.data) do
		if ( not self.db.realm.currentcharonly ) or ( self.db.realm.currentcharonly and character==UnitName("player")  ) then
			table.insert(searchresult,L["Results for "]..character..":")
			for ts,tsinfo in pairs(tradeskill) do
				if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
				if not self.db.realm.ignored_crafts[character][ts] then
					for nb,info in pairs(tsinfo) do
						local match=0
						local craftname=string.lower(info["name"])
						local reg = info["reg"]
						for j=1,#argum do
							if strfind(craftname, string.lower(argum[j])) then match=match+1 
							else 
								local tsdesc=""
								if info.itemlink then
									G:SetHyperlink(info.itemlink)
									for p=1,G:NumLines() do
										tsdesc=tsdesc.." "..G:GetLine(p)
									end
								end
								
								if info.itemlink and strfind(string.lower(tsdesc), string.lower(argum[j])) then match = match+1
								elseif reg then
									local matchfor=false
									for k,v in pairs(reg) do
										if strfind(string.lower(v),string.lower(argum[j])) then matchfor=true end
									end
									if matchfor then match = match+1 end
								end
							end
						end 
						if match==#argum and not info["ignored"] then 
							if info["recipelink"] then table.insert(searchresult,info["recipelink"]) 
							else table.insert(searchresult,info["link"]) 
							end
						end	
					end
				end
			end
			if searchresult[#searchresult]==L["Results for "]..character..":" then table.remove(searchresult,#searchresult) end
		end
	end

	--SendResults(searchresult,sender)
	return searchresult
end

local function QueryProcess(arg1,arg2,arg6,source)
	local argum = GetArgs(arg1," ")
	local sender = arg2
	local firstword = argum[1]
	table.remove(argum,1)
	argum=RecomposeLink(argum)
	
	local handler
	
	
	if firstword == prefix_ench and self.db.realm.trigger_ench then handler=HandleEnchant
	elseif firstword == prefix_gem and self.db.realm.trigger_gem then handler=HandleGem
	elseif firstword == prefix_other and self.db.realm.trigger_other then handler=HandleCraft
	end
	
	if not handler then return end
	
	mem_trigger[sender] = firstword
	if argum[1] and argum[1]=="next" then
		if mem_search[sender]==nil then return end
		mem_next[sender]=mem_next[sender]+self.db.realm.maxresults
		argum=mem_search[sender]
	else
		mem_search[sender]=argum
		mem_next[sender]=0
	end

	if arg6==L["AFK"] or arg6==L["DND"] then 
		self.filterafkdnd[sender] = true 
		self:ScheduleEvent(function() self.filterafkdnd[sender] = false return end, 1)
	end
	
	SendResults(HandleEnchant(argum,sender),sender,source)
end

function CraftList2:CHAT_MSG_GUILD()
	if self.db.realm.guildactive then QueryProcess(arg1,arg2,arg6,"guild") end
end
function CraftList2:CHAT_MSG_WHISPER()
	QueryProcess(arg1,arg2,arg6,"whisper")
end



function CraftList2:OnInitialize()
	CraftList2:RegisterDB("CraftList2DB")
	CraftList2:RegisterDefaults("realm", {
		data = {},
		ignored_crafts={},
		maxresults=10,
		showrequests=true,
		showanswers=true,
		trigger_ench=true,
		trigger_gem=true,
		trigger_other=true,
		guildactive=true,
		shortguild=true,
		currentcharonly=false,
		}
	)  
end
local function BuildOpts()
	local cl2opt={
		type="group",
		name="CraftList2",
		desc="CraftList2",
		args = {
			inc= {
				type="toggle",
				name=L["Show incoming requests"],
				desc=L["Show incoming requests"],
				get=function() return self.db.realm.showrequests end,
				set=function(v) self.db.realm.showrequests = v end,
				order=2,
			},
			out= {
				type="toggle",
				name=L["Show your replies"],
				desc=L["Show your replies"],
				get=function() return self.db.realm.showanswers end,
				set=function(v) self.db.realm.showanswers = v end,
				order=3,
			},
			maxresults= {
				type="range",
				name=L["Maximum results"],
				desc=L["Maximum of results sent to someone (0=no limit)"],
				get=function() return self.db.realm.maxresults end,
				set=function(v) self.db.realm.maxresults = v end,
				min=0,
				max=100,
				step=1,
				order=1,
			},
			guildchat= {
				type="toggle",
				name=L["Monitor Guildchat"],
				desc=L["Monitor Guildchat (results are whispered back)"],
				get=function() return self.db.realm.guildactive end,
				set=function(v) self.db.realm.guildactive = v end,
				order=4,
			},
			shortguild= {
				type="toggle",
				name=L["Short Guildchat answer"],
				desc=L["Only whispers # of results instead of the actual results when queried on guildchat"],
				disabled=function() return not self.db.realm.guildactive end,
				get=function() return self.db.realm.shortguild end,
				set=function(v) self.db.realm.shortguild = v end,
				order=5,
			},
			reset={
				type="execute",
				name=L["Reset all data"],
				desc=L["Reset all stored data for all characters"],
				order=6,
				confirm=true,
				func=function() 
					self.db.realm.data={}
					self.db.realm.ignored_crafts={}
					waterfall:Close('CraftList2')
					return
					end,
			},
			limit={
				type="toggle",
				name=L["Only current character"],
				desc=L["Limit search to the connected character's known crafts"],
				get=function() return self.db.realm.currentcharonly end,
				set=function(v) self.db.realm.currentcharonly = v end,
				order=7,
			},
			localtest={
				type="group",
				name=L["Local Test"],
				desc=L["Print locally results of a query"],
				order=4,
				args=	{
					ench={
						type="text",
						name=prefix_ench,
						desc=(L["Arguments for %s"]):format(prefix_ench),
						order=1,
						get=function() return enchant_localtest end,
						set=function(v) 
							if v and v ~= "" then
								enchant_localtest=v
								local argum = GetArgs(v," ")
								local result=HandleEnchant(argum,nil)
								self:Print((L["Local test for %s"]):format(v))
								if #result==0 then self:Print(L["Nothing found."])
								else
									for i=1,#result or self.db.realm.maxresults do
										self:Print(result[i])
									end
								end
							end
						end,
					},
					gem={
						type="text",
						name=prefix_gem,
						desc=(L["Arguments for %s"]):format(prefix_gem),
						order=2,
						get=function() return gem_localtest end,
						set=function(v) 
							if v and v ~= "" then
								gem_localtest=v
								local argum = GetArgs(v," ")
								local result=HandleGem(argum,nil)
								self:Print((L["Local test for %s"]):format(v))
								if #result==0 then self:Print(L["Nothing found."])
								else
									for i=1,#result or self.db.realm.maxresults do
										self:Print(result[i])
									end
								end
							end
						end,
					},
					craft={
						type="text",
						name=prefix_other,
						desc=(L["Arguments for %s"]):format(prefix_other),
						order=3,
						get=function() return craft_localtest end,
						set=function(v) 
							if v and v ~= "" then
								craft_localtest=v
								local argum = GetArgs(v," ")
								local result=HandleCraft(argum,nil)
								self:Print((L["Local test for %s"]):format(v))
								if #result==0  then self:Print(L["Nothing found."])
								else
									for i=1,#result or self.db.realm.maxresults do
										self:Print(result[i])
									end
								end
							end
						end,
					},
				},
			},
			send={
				type="group",
				name=L["Send"],
				desc=L["Send a list to a player"],
				order=4,
				args={
					enchant={
						name=prefix_ench,
						type="text",
						order=3,
						desc=L["playername query"],
						get=function() return enchant_send end,
						set=function(v) 
							enchant_send=v
							local argum = GetArgs(v, " ")
							sender=argum[1]
							table.remove(argum,1)
							local args=""
							for k,v in pairs(argum) do
								args=args.." "..v
							end
							mem_search[sender]=argum
							mem_next[sender]=0
							QueryProcess(prefix_ench.." "..args,sender,nil,"whisper")
							end				
					},
					gem={
						name=prefix_gem,
						type="text",
						order=4,
						desc=L["playername query"],
						get=function() return gem_send end,
						set=function(v) 
							gem_send=v
							local argum = GetArgs(v, " ")
							sender=argum[1]
							table.remove(argum,1)
							local args=""
							for k,v in pairs(argum) do
								args=args.." "..v
							end
							mem_search[sender]=argum
							mem_next[sender]=0
							QueryProcess(prefix_gem.." "..args,sender,nil,"whisper")
							end		
					},
					craft={
						name=prefix_other,
						type="text",
						order=5,
						desc=L["playername query"],
						get=function() return craft_send end,
						set=function(v) 
							craft_send=v
							local argum = GetArgs(v, " ")
							sender=argum[1]
							table.remove(argum,1)
							local args=""
							for k,v in pairs(argum) do
								args=args.." "..v
							end
							mem_search[sender]=argum
							mem_next[sender]=0
							QueryProcess(prefix_other.." "..args,sender,nil,"whisper")
							end	
					},
				},
			},
			triggers={
				type="group",
				name=L["Triggers"],
				desc=L["Triggers"],
				order=5,
				args={ 
					ench={
						type="toggle",
						name=prefix_ench,
						desc=prefix_ench,
						get=function()
							return self.db.realm.trigger_ench
							end,
						set=function(v)
							self.db.realm.trigger_ench = not self.db.realm.trigger_ench 
							end,
					},
					gem={
						type="toggle",
						name=prefix_gem,
						desc=prefix_gem,
						get=function()
							return self.db.realm.trigger_gem
							end,
						set=function(v)
							self.db.realm.trigger_gem = not self.db.realm.trigger_gem 
							end,
					},
					other={
						type="toggle",
						name=prefix_other,
						desc=prefix_other,
						get=function()
							return self.db.realm.trigger_other
							end,
						set=function(v)
							self.db.realm.trigger_other = not self.db.realm.trigger_other 
							end,
					},
				},
			},
			active= {
				type="group",
				name=L["Active Professions"],
				desc=L["Check here what professions you want to track"],
				args = {},
				order=6,
			},
			ignored = {
				type="group",
				name=L["Active Crafts"],
				desc=L["Uncheck here crafts you want to be ignored"],
				args = {},
				order=7,
			}
		}
	}
	
	local j=1
	local k=1
	for character, tradeskill in pairs(self.db.realm.data) do
		cl2opt.args.ignored.args[j] = 
			{
				type="group",
				name=character,
				desc=character,
				args={},
			}
		local l=1
		for ts,tsinfo in pairs(tradeskill) do
			cl2opt.args.active.args[k] = 
			{
				type="toggle",
				name=character.." - "..ts,
				desc=character.." - "..ts,
				get=function() 
					if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
					return not self.db.realm.ignored_crafts[character][ts] 
					end,
				set=function(v) 
					if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
					self.db.realm.ignored_crafts[character][ts] = not self.db.realm.ignored_crafts[character][ts] 
					end,
			}
			k=k+1
			cl2opt.args.ignored.args[j].args[l] = 
				{
					type="group",
					name=ts,
					desc=ts,
					args={},
					disabled=function() 
					if not self.db.realm.ignored_crafts[character] then self.db.realm.ignored_crafts[character] = {} end
					return self.db.realm.ignored_crafts[character][ts] 
					end,
				}
				
			cl2opt.args.ignored.args[j].args[l].args[1] = 
			{
				type="execute",
				name="Check all",
				desc="Check all",
				order=1,
				func=function() 
					for nb,info in pairs(tsinfo) do
						info.ignored=false
					end
				end,
			}
			cl2opt.args.ignored.args[j].args[l].args[2] = 
			{
				type="execute",
				name="Uncheck all",
				desc="Uncheck all",
				order=2,
				func=function() 
					for nb,info in pairs(tsinfo) do
						info.ignored=true
					end
				end,
			} 
			local m=3
			for nb,info in pairs(tsinfo) do
				local desc = info["desc"]
				if not desc  and info.itemlink then 
					desc=""
					G:SetHyperlink(info["itemlink"])
					for i=1,G:NumLines() do
						desc=desc.."\n"..G:GetLine(i)
					end
				end
				cl2opt.args.ignored.args[j].args[l].args[m] = 
				{
					type="toggle",
					name=info["name"],
					desc= desc,
					order=3,
					get=function()
						return not info.ignored end,
					set=function(v)
						info.ignored = not info.ignored
						end,
				}
				m=m+1
			end
			l=l+1
		end
		j=j+1
	end
	return cl2opt
end

function CraftList2:OnEnable()
	self:Hook("ChatFrame_MessageEventHandler",function(event)
		if arg1 and arg1~="" then
			if (string.sub(arg1,1,string.len(prefix_ench))==prefix_ench and not self.db.realm.showrequests and self.db.realm.trigger_ench and event=="CHAT_MSG_WHISPER") then return end
			if (string.sub(arg1,1,string.len(prefix_gem))==prefix_gem and not self.db.realm.showrequests and self.db.realm.trigger_gem and event=="CHAT_MSG_WHISPER") then return end
			if (string.sub(arg1,1,string.len(prefix_other))==prefix_other and not self.db.realm.showrequests and self.db.realm.trigger_other and event=="CHAT_MSG_WHISPER") then return end
			if (string.sub(arg1,1,string.len(prefix_answers))==prefix_answers and not self.db.realm.showanswers and event=="CHAT_MSG_WHISPER_INFORM") then return end
		end
		return self.hooks["ChatFrame_MessageEventHandler"](event)
		end,
		true)
	self:RegisterEvent("CHAT_MSG_WHISPER")
	self:RegisterEvent("CRAFT_SHOW")
	self:RegisterEvent("TRADE_SKILL_SHOW")
	self:RegisterEvent("CHAT_MSG_GUILD")
	self:Hook("ChatFrame_OnEvent", function()
		local author = arg2
			if ( event == "CHAT_MSG_AFK" or event == "CHAT_MSG_DND") then
				if self.filterafkdnd[author] then return end
			end
		return self.hooks["ChatFrame_OnEvent"](event)
		end, 
		true)
	self.filterafkdnd={}
	
	local options={
		type="group",
		args = {
			menu={
				name=L["Menu"],
				desc=L["Menu"],
				type ='execute',
				order=1,
				func = function()
					if waterfall:IsRegistered('CraftList2') then waterfall:UnRegister('CraftList2') end
					waterfall:Register('CraftList2', 
						'aceOptions',BuildOpts(),
						'title','CraftList2'
					)
					waterfall:Open('CraftList2')
					end
			},
			header={
				name=L["Send a list to a player"],
				type="header",
				order=2,
			},
			enchant={
				name=prefix_ench,
				desc=L["Send a list to a player"],
				type="text",
				order=3,
				usage=L["playername query"],
				get=false,
				set=function(v) 
					local argum = GetArgs(v, " ")
					sender=argum[1]
					table.remove(argum,1)
					local args=""
					for k,v in pairs(argum) do
						args=args.." "..v
					end
					mem_search[sender]=argum
					mem_next[sender]=0
					QueryProcess(prefix_ench.." "..args,sender,nil,"whisper")
					end				
			},
			gem={
				name=prefix_gem,
				desc=L["Send a list to a player"],
				type="text",
				order=4,
				usage=L["playername query"],
				get=false,
				set=function(v) 
					local argum = GetArgs(v, " ")
					sender=argum[1]
					table.remove(argum,1)
					local args=""
					for k,v in pairs(argum) do
						args=args.." "..v
					end
					mem_search[sender]=argum
					mem_next[sender]=0
					QueryProcess(prefix_gem.." "..args,sender,nil,"whisper")
					end		
			},
			craft={
				name=prefix_other,
				desc=L["Send a list to a player"],
				type="text",
				order=5,
				usage=L["playername query"],
				get=false,
				set=function(v) 
					local argum = GetArgs(v, " ")
					sender=argum[1]
					table.remove(argum,1)
					local args=""
					for k,v in pairs(argum) do
						args=args.." "..v
					end
					mem_search[sender]=argum
					mem_next[sender]=0
					QueryProcess(prefix_other.." "..args,sender,nil,"whisper")
					end	
			},
		},
	}
	
	self:RegisterChatCommand('/clist', '/craftlist', '/clist2', '/craftlist2', options)
end

function CraftList2:OnDisable()
	self:UnhookAll()
	self:UnregisterEvent("CHAT_MSG_WHISPER")
	self:UnregisterEvent("CRAFT_SHOW")
	self:UnregisterEvent("TRADE_SKILL_SHOW")
	self:UnregisterEvent("CHAT_MSG_GUILD")
end
